VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Icons and PictureBox"
   ClientHeight    =   2370
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4590
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2370
   ScaleWidth      =   4590
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   3840
      Top             =   1200
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
      CancelError     =   -1  'True
      DialogTitle     =   "Choose an executable file"
      Filter          =   "EXE|*.exe|DLL|*.dll;*.drv;*.ocx|Icons|*.ico;*.icl"
      FontSize        =   8,49725e-19
   End
   Begin VB.Frame Frame2 
      Caption         =   "Exploring Icons"
      Height          =   2055
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4335
      Begin VB.CommandButton cmdNext 
         Caption         =   ">"
         Height          =   375
         Left            =   1080
         TabIndex        =   6
         Top             =   960
         Width           =   255
      End
      Begin VB.CommandButton cmdPrev 
         Caption         =   "<"
         Height          =   375
         Left            =   720
         TabIndex        =   5
         Top             =   960
         Width           =   255
      End
      Begin VB.TextBox Text2 
         Height          =   285
         Left            =   3840
         MaxLength       =   2
         TabIndex        =   3
         Text            =   "0"
         Top             =   360
         Width           =   375
      End
      Begin VB.CommandButton cmdBrowse 
         Caption         =   "Browse"
         Height          =   375
         Left            =   120
         TabIndex        =   2
         Top             =   360
         Width           =   1215
      End
      Begin VB.PictureBox Picture1 
         Height          =   975
         Left            =   1440
         ScaleHeight     =   915
         ScaleWidth      =   915
         TabIndex        =   1
         Top             =   360
         Width           =   975
      End
      Begin VB.Label Label2 
         Caption         =   "of"
         Height          =   255
         Left            =   2520
         TabIndex        =   9
         Top             =   720
         Width           =   375
      End
      Begin VB.Label Label1 
         Caption         =   "The icon shown is "
         Height          =   255
         Left            =   2520
         TabIndex        =   8
         Top             =   360
         Width           =   1335
      End
      Begin VB.Label lblTotal 
         Height          =   255
         Left            =   2880
         TabIndex        =   7
         Top             =   720
         Width           =   615
      End
      Begin VB.Label lblFile 
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   1680
         Width           =   4095
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private g_iNumOfIcons As Long
Private g_iCurrentIcon As Long
Private g_hInstance As Long

Private Sub cmdBrowse_Click()
On Error GoTo Error
    CommonDialog1.ShowOpen
    lblFile.Caption = CommonDialog1.filename
        
    g_iNumOfIcons = ExtractIcon(g_hInstance, CommonDialog1.filename, -1)
    lblTotal.Caption = Str$(g_iNumOfIcons)
    If g_iNumOfIcons <= 0 Then
        cmdNext.Enabled = False
        cmdPrev.Enabled = False
    Else
        cmdNext.Enabled = True
        cmdPrev.Enabled = True
    End If
    VB_ShowIcon CommonDialog1.filename, 0
    Exit Sub
Error:
End Sub

Private Sub cmdNext_Click()
    If g_iNumOfIcons < 0 Then
        Beep
        Exit Sub
    End If
    g_iCurrentIcon = Val(Text2.Text) + 1
    If g_iCurrentIcon >= g_iNumOfIcons Then
        g_iCurrentIcon = g_iNumOfIcons - 1
        Text2.Text = Trim$(Str$(g_iCurrentIcon))
        Beep
        Exit Sub
    End If
    Text2.Text = Trim$(Str$(g_iCurrentIcon))
    VB_ShowIcon lblFile.Caption, g_iCurrentIcon
End Sub

Private Sub cmdPrev_Click()
    If g_iNumOfIcons < 0 Then
        Beep
        Exit Sub
    End If
    g_iCurrentIcon = Val(Text2.Text) - 1
    If g_iCurrentIcon < 0 Then
        g_iCurrentIcon = 0
        Text2.Text = Trim$(Str$(g_iCurrentIcon))
        Beep
        Exit Sub
    End If
    Text2.Text = Trim$(Str$(g_iCurrentIcon))
    VB_ShowIcon lblFile.Caption, g_iCurrentIcon
End Sub

Private Sub VB_ShowIcon(ByVal szFileName As String, ByVal iIndex As Integer)
On Error Resume Next
    Dim hIcon As Long
                
    ' check file name
    If Len(szFileName) = 0 Then
        MsgBox "Incorrect file name."
        Exit Sub
    End If
   
    
    ' check icon index
    If iIndex > g_iNumOfIcons - 1 Then
        Beep
        Exit Sub
    End If
    
    
    ' extract the icon and convert to IPictureDisp
    hIcon = ExtractIcon(hInstance, szFileName, iIndex)
    Picture1.Picture = HIconToPicture(hIcon)
End Sub

Private Function HIconToPicture(ByVal hIcon As Long) As IPictureDisp
    Dim picDesc As ICONDESC
    Dim iid As GUID
    Dim pic As IPictureDisp
    
    ' Set PICTDESC to convert HICONs.
    ' The length of the struct should be 20 bytes.
    picDesc.cbSizeOfStruct = Len(picDesc)
    picDesc.picType = PICTYPE_ICON
    picDesc.hIcon = hIcon
    
    ' This is the original IPictureDisp's GUID
    ' DEFINE_GUID(IID_IPictureDisp,
    '   0x7Bf80981,0xBF32,0x101A,0x8B,0xBB,0x00,0xAA,0x00,0x30,0x0C,0xAB);
    iid.Data1 = &H7BF80981
    iid.Data2 = &HBF32
    iid.Data3 = &H101A
    iid.BData1 = &H8B
    iid.BData2 = &HBB
    iid.BData3 = &H0
    iid.BData4 = &HAA
    iid.BData5 = &H0
    iid.BData6 = &H30
    iid.BData7 = &HC
    iid.BData8 = &HAB
    
    ' convert to IPictureDisp
    OleInitialize ByVal 0&
    hr = OleCreateIconIndirect(picDesc, iid, True, pic)
    OleUninitialize
    
    ' Set the return value
    Set HIconToPicture = pic
End Function

Private Sub Form_Load()
    g_hInstance = GetWindowLong(Form1.hwnd, GWL_HINSTANCE)
    g_iNumOfIcons = -1
    cmdNext.Enabled = False
    cmdPrev.Enabled = False
End Sub

Private Sub Text2_Change()
    VB_ShowIcon lblFile.Caption, Val(Text2.Text)
End Sub
